// file: $isip_ifc/class/algo/Constant/const_01.cc
// version: $Id: const_01.cc 10532 2006-03-29 21:26:30Z raghavan $
//

// isip include files
//
#include "Constant.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean Constant::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String output;
  String value;
  
  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm choice
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP((long)algorithm_d));
  Console::put(output);
  
  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((long)implementation_d));
  Console::put(output);
  
  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"data_type_d",
                  AlgorithmData::DTYPE_MAP.getName((long)data_type_d));
  Console::put(output);

  // display the file name
  //
  value.assign(filename_d);
  output.debugStr(name(), msg_a, L"filename_d", value);
  Console::put(output);

  // display the channels
  //
  value.assign(channels_d);
  output.debugStr(name(), msg_a, L"channels_d", value);
  Console::put(output);
  
  // display the status flag
  //
  value.assign(data_exist_d);
  output.debugStr(name(), msg_a, L"data_exist_d", value);
  Console::put(output);
  
  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");

  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
